Index: code/trunk/src/core/CommandExecutor.cc
===================================================================
--- code/trunk/src/core/CommandExecutor.cc	(revision 1407)
+++ code/trunk/src/core/CommandExecutor.cc	(revision 1502)
@@ -384,866 +99,407 @@
     {
         if (useTcl)
-        {
             return TclBind::eval(command);
-        }
-        else
-        {
-            if ((CommandExecutor::getEvaluation().processedCommand_ != command) || (CommandExecutor::getEvaluation().state_ == CS_Uninitialized))
-                CommandExecutor::parse(command);
-
-            return CommandExecutor::execute(CommandExecutor::getEvaluation());
-        }
-    }
-
-
-    bool CommandExecutor::execute(const CommandEvaluation& evaluation)
-    {
-        SubString tokens(evaluation.processedCommand_, " ", SubString::WhiteSpaces, false, '\\', false, '"', false, '(', ')', false, '\0');
-
-        if (evaluation.bEvaluatedParams_ && evaluation.evaluatedExecutor_)
-        {
-std::cout << "CE_execute (evaluation): " << evaluation.evaluatedExecutor_->getName() << " " << evaluation.param_[0] << " " << evaluation.param_[1] << " " << evaluation.param_[2] << " " << evaluation.param_[3] << " " << evaluation.param_[4] << std::endl;
-            (*evaluation.evaluatedExecutor_)(evaluation.param_[0], evaluation.param_[1], evaluation.param_[2], evaluation.param_[3], evaluation.param_[4]);
-            return true;
-        }
-
-std::cout << "CE_execute: " << evaluation.processedCommand_ << "\n";
-        switch (evaluation.state_)
-        {
-            case CS_Uninitialized:
-                break;
-            case CS_Empty:
-                break;
-            case CS_FunctionClass_Or_Shortcut_Or_Keyword:
-                break;
-            case CS_Shortcut_Params:
-                // not enough parameters but lets hope there are some additional parameters and go on
-            case CS_Shortcut_Finished:
-                // call the shortcut
-                if (evaluation.shortcut_)
-                {
-                    if (tokens.size() >= 2)
-                        return evaluation.shortcut_->parse(removeSlashes(tokens.subSet(1).join() + evaluation.getAdditionalParameter()));
-                    else
-                        return evaluation.shortcut_->parse(removeSlashes(evaluation.additionalParameter_));
-                }
-                break;
-            case CS_Function:
-                break;
-            case CS_Function_Params:
-                // not enough parameters but lets hope there are some additional parameters and go on
-            case CS_Function_Finished:
-                // call the shortcut
-                if (evaluation.function_)
-                {
-                    if (tokens.size() >= 3)
-                        return evaluation.function_->parse(removeSlashes(tokens.subSet(2).join() + evaluation.getAdditionalParameter()));
-                    else
-                        return evaluation.function_->parse(removeSlashes(evaluation.additionalParameter_));
-                }
-                break;
-            case CS_ConfigValueClass:
-                break;
-            case CS_ConfigValue:
-                break;
-            case CS_ConfigValueType:
-                // not enough parameters but lets hope there are some additional parameters and go on
-            case CS_ConfigValueFinished:
-                // set the config value
-                if (evaluation.configvalue_)
-                {
-                    if ((tokens.size() >= 1) && (tokens[0] == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE))
-                    {
-                        if (tokens.size() >= 4)
-                            return evaluation.configvalue_->set(removeSlashes(tokens.subSet(3).join() + evaluation.getAdditionalParameter()));
-                        else
-                            return evaluation.configvalue_->set(removeSlashes(evaluation.additionalParameter_));
-                    }
-                    else if ((tokens.size() >= 1) && (tokens[0] == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY))
-                    {
-                        if (tokens.size() >= 4)
-                            return evaluation.configvalue_->tset(removeSlashes(tokens.subSet(3).join() + evaluation.getAdditionalParameter()));
-                        else
-                            return evaluation.configvalue_->tset(removeSlashes(evaluation.additionalParameter_));
-                    }
-                }
-                break;
-            case CS_KeybindKey:
-                break;
-            case CS_KeybindCommand:
-                // not enough parameters but lets hope there are some additional parameters and go on
-            case CS_KeybindFinished:
-                // set the keybind
-                // ...todo
-                break;
-            case CS_Error:
-                break;
-        }
-
-        return false;
+
+        CommandExecutor::parseIfNeeded(command);
+        return CommandExecutor::getEvaluation().execute();
     }
 
     std::string CommandExecutor::complete(const std::string& command)
     {
-        if ((CommandExecutor::getEvaluation().processedCommand_ != command) || (CommandExecutor::getEvaluation().state_ == CS_Uninitialized))
-            CommandExecutor::parse(command);
-
-        return CommandExecutor::complete(CommandExecutor::getEvaluation());
-    }
-
-    std::string CommandExecutor::complete(const CommandEvaluation& evaluation)
-    {
-        SubString tokens(evaluation.processedCommand_, " ", SubString::WhiteSpaces, false, '\\', false, '"', false, '(', ')', false, '\0');
-
-        std::list<std::pair<const std::string*, const std::string*> > temp;
-        if (evaluation.state_ == CS_Empty)
-        {
-            temp.insert(temp.end(), evaluation.listOfPossibleShortcuts_.begin(), evaluation.listOfPossibleShortcuts_.end());
-            temp.insert(temp.end(), evaluation.listOfPossibleFunctionClasses_.begin(), evaluation.listOfPossibleFunctionClasses_.end());
-        }
-
-        switch (evaluation.state_)
-        {
-            case CS_Uninitialized:
-                break;
-            case CS_Empty:
-                return (CommandExecutor::getCommonBegin(temp));
-                break;
-            case CS_FunctionClass_Or_Shortcut_Or_Keyword:
-                break;
-            case CS_Shortcut_Params:
-                if (evaluation.shortcut_)
-                    return (evaluation.shortcut_->getName() + " ");
-                break;
-            case CS_Shortcut_Finished:
-                if (evaluation.shortcut_)
-                {
-                    if (evaluation.shortcut_->getParamCount() == 0)
-                        return (evaluation.shortcut_->getName());
-                    else if (tokens.size() >= 2)
-                        return (evaluation.shortcut_->getName() + " " + tokens.subSet(1).join());
-                }
-                break;
-            case CS_Function:
-                if (evaluation.functionclass_)
-                    return (evaluation.functionclass_->getName() + " " + CommandExecutor::getCommonBegin(evaluation.listOfPossibleFunctions_));
-                break;
-            case CS_Function_Params:
-                if (evaluation.functionclass_ && evaluation.function_)
-                    return (evaluation.functionclass_->getName() + " " + evaluation.function_->getName() + " ");
-                break;
-            case CS_Function_Finished:
-                if (evaluation.functionclass_ && evaluation.function_)
-                {
-                    if (evaluation.function_->getParamCount() == 0)
-                        return (evaluation.functionclass_->getName() + " " + evaluation.function_->getName());
-                    else if (tokens.size() >= 3)
-                        return (evaluation.functionclass_->getName() + " " + evaluation.function_->getName() + " " + tokens.subSet(2).join());
-                }
-                break;
-            case CS_ConfigValueClass:
-                if (tokens.size() >= 1)
-                    return (tokens[0] + " " + CommandExecutor::getCommonBegin(evaluation.listOfPossibleConfigValueClasses_));
-                break;
-            case CS_ConfigValue:
-                if ((tokens.size() >= 1) && evaluation.configvalueclass_)
-                    return (tokens[0] + " " + evaluation.configvalueclass_->getName() + " " + CommandExecutor::getCommonBegin(evaluation.listOfPossibleConfigValues_));
-                break;
-            case CS_ConfigValueType:
-                if ((tokens.size() >= 1) && evaluation.configvalueclass_ && evaluation.configvalue_)
-                    return (tokens[0] + " " + evaluation.configvalueclass_->getName() + " " + evaluation.configvalue_->getName() + " ");
-                break;
-            case CS_ConfigValueFinished:
-                if ((tokens.size() >= 1) && evaluation.configvalueclass_ && evaluation.configvalue_ && (tokens.size() >= 4))
-                    return (tokens[0] + " " + evaluation.configvalueclass_->getName() + " " + evaluation.configvalue_->getName() + " " + tokens.subSet(3).join());
-                break;
-            case CS_KeybindKey:
-                if (tokens.size() >= 1)
-                    return (tokens[0] + " " + CommandExecutor::getCommonBegin(evaluation.listOfPossibleKeys_));
-                break;
-            case CS_KeybindCommand:
-                if ((evaluation.processedCommand_.size() >= 1) && (evaluation.processedCommand_[evaluation.processedCommand_.size() - 1] != ' '))
-                    return (evaluation.processedCommand_ + " ");
-                break;
-            case CS_KeybindFinished:
-                break;
-            case CS_Error:
-                break;
-        }
-
-        return evaluation.processedCommand_;
+        CommandExecutor::parseIfNeeded(command);
+        return CommandExecutor::getEvaluation().complete();
     }
 
     std::string CommandExecutor::hint(const std::string& command)
     {
-        if ((CommandExecutor::getEvaluation().processedCommand_ != command) || (CommandExecutor::getEvaluation().state_ == CS_Uninitialized))
-            CommandExecutor::parse(command);
-
-        return CommandExecutor::hint(CommandExecutor::getEvaluation());
-    }
-
-    std::string CommandExecutor::hint(const CommandEvaluation& evaluation)
-    {
-        SubString tokens(evaluation.processedCommand_, " ", SubString::WhiteSpaces, false, '\\', false, '"', false, '(', ')', false, '\0');
-
-        switch (evaluation.state_)
-        {
-            case CS_Uninitialized:
-                break;
-            case CS_Empty:
-                return (CommandExecutor::dump(evaluation.listOfPossibleShortcuts_) + "\n" + CommandExecutor::dump(evaluation.listOfPossibleFunctionClasses_));
-                break;
-            case CS_FunctionClass_Or_Shortcut_Or_Keyword:
-                break;
-            case CS_Shortcut_Params:
-                if (evaluation.shortcut_)
-                    return CommandExecutor::dump(evaluation.shortcut_);
-                break;
-            case CS_Shortcut_Finished:
-                if (evaluation.shortcut_)
-                    return CommandExecutor::dump(evaluation.shortcut_);
-                break;
-            case CS_Function:
-                return CommandExecutor::dump(evaluation.listOfPossibleFunctions_);
-                break;
-            case CS_Function_Params:
-                if (evaluation.function_)
-                    return CommandExecutor::dump(evaluation.function_);
-                break;
-            case CS_Function_Finished:
-                if (evaluation.function_)
-                    return CommandExecutor::dump(evaluation.function_);
-                break;
-            case CS_ConfigValueClass:
-                return CommandExecutor::dump(evaluation.listOfPossibleConfigValueClasses_);
-                break;
-            case CS_ConfigValue:
-                return CommandExecutor::dump(evaluation.listOfPossibleConfigValues_);
-                break;
-            case CS_ConfigValueType:
-                if (evaluation.configvalue_)
-                    return CommandExecutor::dump(evaluation.configvalue_);
-                break;
-            case CS_ConfigValueFinished:
-                if (evaluation.configvalue_)
-                    return CommandExecutor::dump(evaluation.configvalue_);
-                break;
-            case CS_KeybindKey:
-                return CommandExecutor::dump(evaluation.listOfPossibleKeys_);
-                break;
-            case CS_KeybindCommand:
-                if (evaluation.key_)
-                    return CommandExecutor::dump(evaluation.key_);
-                break;
-            case CS_KeybindFinished:
-                if (evaluation.key_)
-                    return CommandExecutor::dump(evaluation.key_);
-                break;
-            case CS_Error:
-                return CommandExecutor::getEvaluation().errorMessage_;
-                break;
-        }
-
-        return "";
+        CommandExecutor::parseIfNeeded(command);
+        return CommandExecutor::getEvaluation().hint();
     }
 
     CommandEvaluation CommandExecutor::evaluate(const std::string& command)
     {
-        CommandExecutor::parse(command, true);
-
-        if (CommandExecutor::getEvaluation().tokens_.size() > 0)
-        {
-            std::string lastToken;
-            lastToken = CommandExecutor::getEvaluation().tokens_[CommandExecutor::getEvaluation().tokens_.size() - 1];
-            lastToken = lastToken.substr(0, lastToken.size() - 1);
-            CommandExecutor::getEvaluation().tokens_.pop_back();
-            CommandExecutor::getEvaluation().tokens_.append(SubString(lastToken, " ", "", true, '\0', false, '\0', false, '\0', '\0', false, '\0'));
-        }
-
+        CommandExecutor::parse(command);
         CommandExecutor::getEvaluation().evaluateParams();
         return CommandExecutor::getEvaluation();
     }
 
+    void CommandExecutor::parseIfNeeded(const std::string& command)
+    {
+        if (CommandExecutor::getEvaluation().state_ == CS_Uninitialized)
+        {
+            CommandExecutor::parse(command);
+        }
+        else if (CommandExecutor::getEvaluation().originalCommand_ != command)
+        {
+            if (CommandExecutor::getEvaluation().command_ == command)
+            {
+                CommandExecutor::parse(command);
+                CommandExecutor::getEvaluation().bNewCommand_ = false;
+            }
+            else
+            {
+                CommandExecutor::parse(command);
+            }
+        }
+    }
+
     void CommandExecutor::parse(const std::string& command, bool bInitialize)
     {
-        CommandExecutor::getEvaluation().tokens_.split((command + COMMAND_EXECUTOR_CURSOR), " ", SubString::WhiteSpaces, false, '\\', false, '"', false, '(', ')', false, '\0');
-        CommandExecutor::getEvaluation().processedCommand_ = command;
-
         if (bInitialize)
-            CommandExecutor::initialize(command);
+            CommandExecutor::getEvaluation().initialize(command);
+
+        CommandExecutor::getEvaluation().commandTokens_.split(command, " ", SubString::WhiteSpaces, false, '\\', false, '"', false, '(', ')', false, '\0');
+        CommandExecutor::getEvaluation().command_ = command;
 
         switch (CommandExecutor::getEvaluation().state_)
         {
             case CS_Uninitialized:
+            {
                 // Impossible
                 break;
+            }
             case CS_Empty:
+            {
                 if (CommandExecutor::argumentsGiven() == 0)
                 {
-                    // We want a hint for the first token
-                    // Check if there is already a perfect match
-                    CommandExecutor::getEvaluation().functionclass_ = CommandExecutor::getIdentifierOfPossibleFunctionClass(CommandExecutor::getToken(0));
-                    CommandExecutor::getEvaluation().shortcut_ = CommandExecutor::getExecutorOfPossibleShortcut(CommandExecutor::getToken(0));
-
-                    if ((CommandExecutor::getEvaluation().functionclass_) || (CommandExecutor::getEvaluation().shortcut_))
-                    {
-                        // Yes, there is a class or a shortcut with the searched name
-                        // Add a whitespace and continue parsing
-                        CommandExecutor::getEvaluation().state_ = CS_FunctionClass_Or_Shortcut_Or_Keyword;
-                        CommandExecutor::parse(command + " ", false);
+                    CommandExecutor::createListOfPossibleFunctions("");
+                    CommandExecutor::createListOfPossibleIdentifiers("");
+                    break;
+                }
+                else
+                {
+                    CommandExecutor::getEvaluation().state_ = CS_ShortcutOrIdentifier;
+                    // Move on to next case
+                }
+            }
+            case CS_ShortcutOrIdentifier:
+            {
+                if (CommandExecutor::argumentsGiven() > 1)
+                {
+                    // There's a finished first argument - check if it's a shortcut or a classname
+                    CommandExecutor::getEvaluation().function_ = CommandExecutor::getPossibleCommand(CommandExecutor::getArgument(0));
+                    CommandExecutor::getEvaluation().functionclass_ = CommandExecutor::getPossibleIdentifier(CommandExecutor::getArgument(0));
+
+                    if (CommandExecutor::getEvaluation().function_)
+                    {
+                        // It's a shortcut
+                        CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
+                        CommandExecutor::getEvaluation().functionclass_ = 0;
+                        // Move on to next case
+                    }
+                    else if (CommandExecutor::getEvaluation().functionclass_)
+                    {
+                        // It's a functionname
+                        CommandExecutor::getEvaluation().state_ = CS_Function;
+                        CommandExecutor::getEvaluation().function_ = 0;
+                        // Move on to next case
+                    }
+                    else
+                    {
+                        // The first argument is bad
+                        CommandExecutor::getEvaluation().state_ = CS_Error;
+                        AddLanguageEntry("commandexecutorunknownfirstargument", "is not a shortcut nor a classname");
+                        CommandExecutor::getEvaluation().errorMessage_ = "Error: " + CommandExecutor::getArgument(0) + " " + GetLocalisation("commandexecutorunknownfirstargument") + ".";
                         return;
                     }
-
-                    // No perfect match: Create the lists of all possible classes and shortcuts and return
-                    CommandExecutor::createListOfPossibleFunctionClasses(CommandExecutor::getToken(0));
-                    CommandExecutor::createListOfPossibleShortcuts(CommandExecutor::getToken(0));
-
-                    // Check if there's only one possiblility
-                    if ((CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.size() == 1) && (CommandExecutor::getEvaluation().listOfPossibleShortcuts_.size() == 0))
-                    {
-                        // There's only one possible class
+                }
+                else
+                {
+                    // There's no finished first argument - search possible shortcuts or classnames
+                    CommandExecutor::createListOfPossibleFunctions(CommandExecutor::getArgument(0));
+                    CommandExecutor::createListOfPossibleIdentifiers(CommandExecutor::getArgument(0));
+
+                    unsigned int num_functions = CommandExecutor::getEvaluation().listOfPossibleFunctions_.size();
+                    unsigned int num_identifiers = CommandExecutor::getEvaluation().listOfPossibleIdentifiers_.size();
+
+                    if (num_functions == 1 && num_identifiers == 0)
+                    {
+                        // It's a shortcut
+                        std::string functionname = *(*CommandExecutor::getEvaluation().listOfPossibleFunctions_.begin()).first;
+                        CommandExecutor::getEvaluation().function_ = CommandExecutor::getPossibleCommand(functionname);
+                        if (getLowercase(functionname) != getLowercase(CommandExecutor::getArgument(0)))
+                        {
+                            // Unfinished shortcut
+                            CommandExecutor::getEvaluation().bCommandChanged_ = true;
+                        }
+                        CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
+                        CommandExecutor::getEvaluation().functionclass_ = 0;
+                        CommandExecutor::getEvaluation().command_ = CommandExecutor::getEvaluation().function_->getName();
+                        if (CommandExecutor::getEvaluation().function_->getParamCount() > 0)
+                        {
+                            CommandExecutor::getEvaluation().command_ += " ";
+                            CommandExecutor::getEvaluation().bCommandChanged_ = true;
+                        }
+                        // Move on to next case
+                    }
+                    else if (num_identifiers == 1 && num_functions == 0)
+                    {
+                        // It's a classname
+                        std::string classname = *(*CommandExecutor::getEvaluation().listOfPossibleIdentifiers_.begin()).first;
+                        CommandExecutor::getEvaluation().functionclass_ = CommandExecutor::getPossibleIdentifier(classname);
+                        if (getLowercase(classname) != getLowercase(CommandExecutor::getArgument(0)))
+                        {
+                            // Unfinished classname
+                            CommandExecutor::getEvaluation().bCommandChanged_ = true;
+                        }
                         CommandExecutor::getEvaluation().state_ = CS_Function;
-                        CommandExecutor::getEvaluation().functionclass_ = CommandExecutor::getIdentifierOfPossibleFunctionClass(*(*CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.begin()).first);
-                        CommandExecutor::parse(*(*CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.begin()).first + " ", false);
+                        CommandExecutor::getEvaluation().function_ = 0;
+                        CommandExecutor::getEvaluation().command_ = CommandExecutor::getEvaluation().functionclass_->getName() + " ";
+                        // Move on to next case
+                    }
+                    else if (num_identifiers == 0 && num_functions == 0)
+                    {
+                        // No possibilities
+                        CommandExecutor::getEvaluation().state_ = CS_Error;
+                        AddLanguageEntry("commandexecutorunknownfirstargumentstart", "There is no command or classname starting with");
+                        CommandExecutor::getEvaluation().errorMessage_ = "Error: " + GetLocalisation("commandexecutorunknownfirstargumentstart") + " " + CommandExecutor::getArgument(0) + ".";
                         return;
                     }
-                    else if ((CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.size() == 0) && (CommandExecutor::getEvaluation().listOfPossibleShortcuts_.size() == 1))
-                    {
-                        if ((*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first != COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE)
-                         && (*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first != COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY)
-                         && (*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first != COMMAND_EXECUTOR_KEYWORD_SET_KEYBIND))
-                        {
-                            // There's only one possible shortcut
-                            CommandExecutor::getEvaluation().state_ = CS_Shortcut_Params;
-                            CommandExecutor::getEvaluation().shortcut_ = CommandExecutor::getExecutorOfPossibleShortcut(*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first);
-                        }
-                        else if ((*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE)
-                              || (*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY))
-                        {
-                            // It's the 'set' or 'tset' keyword
-                            CommandExecutor::getEvaluation().state_ = CS_ConfigValueClass;
-                        }
-                        else if (*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first != COMMAND_EXECUTOR_KEYWORD_SET_KEYBIND)
-                        {
-                            // It's the 'bind' keyword
-                            CommandExecutor::getEvaluation().state_ = CS_KeybindKey;
-                        }
-
-                        CommandExecutor::parse(*(*CommandExecutor::getEvaluation().listOfPossibleShortcuts_.begin()).first + " ", false);
+                    else
+                    {
+                        // There are several possiblilities
+                        std::list<std::pair<const std::string*, const std::string*> > temp;
+                        temp.insert(temp.end(), CommandExecutor::getEvaluation().listOfPossibleFunctions_.begin(), CommandExecutor::getEvaluation().listOfPossibleFunctions_.end());
+                        temp.insert(temp.end(), CommandExecutor::getEvaluation().listOfPossibleIdentifiers_.begin(), CommandExecutor::getEvaluation().listOfPossibleIdentifiers_.end());
+                        CommandExecutor::getEvaluation().command_ = CommandExecutor::getCommonBegin(temp);
+                        CommandExecutor::getEvaluation().function_ = CommandExecutor::getPossibleCommand(CommandExecutor::getArgument(0));
+                        CommandExecutor::getEvaluation().functionclass_ = CommandExecutor::getPossibleIdentifier(CommandExecutor::getArgument(0));
+                        CommandExecutor::getEvaluation().bCommandChanged_ = true;
                         return;
                     }
-
-                    // It's ambiguous
+                }
+            }
+            case CS_Function:
+            {
+                if (CommandExecutor::getEvaluation().functionclass_)
+                {
+                    // There is a classname - search for the commandname
+                    if (CommandExecutor::argumentsGiven() > 2)
+                    {
+                        // There is a finished second argument - check if it's a commandname
+                        CommandExecutor::getEvaluation().function_ = CommandExecutor::getPossibleCommand(CommandExecutor::getArgument(1), CommandExecutor::getEvaluation().functionclass_);
+
+                        if (CommandExecutor::getEvaluation().function_)
+                        {
+                            // It's a function
+                            CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
+                            // Move on to next case
+                        }
+                        else
+                        {
+                            // The second argument is bad
+                            CommandExecutor::getEvaluation().state_ = CS_Error;
+                            AddLanguageEntry("commandexecutorunknownsecondargument", "is not a function of");
+                            CommandExecutor::getEvaluation().errorMessage_ = "Error: " + CommandExecutor::getArgument(1) + " " + GetLocalisation("commandexecutorunknownsecondargument") + " " + CommandExecutor::getEvaluation().functionclass_->getName() + ".";
+                            return;
+                        }
+                    }
+                    else
+                    {
+                        // There is no finished second argument - search for possibilities
+                        CommandExecutor::createListOfPossibleFunctions(CommandExecutor::getArgument(1), CommandExecutor::getEvaluation().functionclass_);
+                        unsigned int num_functions = CommandExecutor::getEvaluation().listOfPossibleFunctions_.size();
+
+                        if (num_functions == 1)
+                        {
+                            // It's a function
+                            std::string functionname = *(*CommandExecutor::getEvaluation().listOfPossibleFunctions_.begin()).first;
+                            CommandExecutor::getEvaluation().function_ = CommandExecutor::getPossibleCommand(functionname, CommandExecutor::getEvaluation().functionclass_);
+                            if (getLowercase(functionname) != getLowercase(CommandExecutor::getArgument(1)))
+                            {
+                                // Unfinished function
+                                CommandExecutor::getEvaluation().bCommandChanged_ = true;
+                            }
+                            CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
+                            CommandExecutor::getEvaluation().command_ = CommandExecutor::getEvaluation().functionclass_->getName() + " " + CommandExecutor::getEvaluation().function_->getName();
+                            if (CommandExecutor::getEvaluation().function_->getParamCount() > 0)
+                            {
+                                CommandExecutor::getEvaluation().command_ += " ";
+                                CommandExecutor::getEvaluation().bCommandChanged_ = true;
+                            }
+                            // Move on to next case
+                        }
+                        else if (num_functions == 0)
+                        {
+                            // No possibilities
+                            CommandExecutor::getEvaluation().state_ = CS_Error;
+                            AddLanguageEntry("commandexecutorunknownsecondargumentstart", "has no function starting with");
+                            CommandExecutor::getEvaluation().errorMessage_ = "Error: " + CommandExecutor::getEvaluation().functionclass_->getName() + " " + GetLocalisation("commandexecutorunknownsecondargumentstart") + " " + CommandExecutor::getArgument(1) + ".";
+                            return;
+                        }
+                        else
+                        {
+                            // There are several possibilities
+                            CommandExecutor::getEvaluation().command_ = CommandExecutor::getEvaluation().functionclass_->getName() + " " + CommandExecutor::getCommonBegin(CommandExecutor::getEvaluation().listOfPossibleFunctions_);
+                            CommandExecutor::getEvaluation().function_ = CommandExecutor::getPossibleCommand(CommandExecutor::getArgument(1), CommandExecutor::getEvaluation().functionclass_);
+                            CommandExecutor::getEvaluation().bCommandChanged_ = true;
+                            return;
+                        }
+                    }
+                }
+                else
+                {
+                    // There is no classname - move on to CS_ParamPreparation
+                }
+            }
+            case CS_ParamPreparation:
+            {
+                if (CommandExecutor::getEvaluation().function_->getParamCount() == 0 || CommandExecutor::enoughArgumentsGiven(CommandExecutor::getEvaluation().function_))
+                {
+                    CommandExecutor::getEvaluation().state_ = CS_Finished;
                     return;
                 }
                 else
                 {
-                    // There is at least one argument: Check if it's a shortcut, a classname or a special keyword
-                    CommandExecutor::getEvaluation().state_ = CS_FunctionClass_Or_Shortcut_Or_Keyword;
-                    CommandExecutor::parse(command, false);
+                    unsigned int argumentNumber = CommandExecutor::argumentsGiven() - 2;
+                    if (CommandExecutor::getEvaluation().functionclass_)
+                        argumentNumber -= 1;
+
+                    CommandExecutor::createListOfPossibleArguments(CommandExecutor::getLastArgument(), CommandExecutor::getEvaluation().function_, argumentNumber);
+                    CommandExecutor::getEvaluation().state_ = CS_Params;
+
+                    if (CommandExecutor::getEvaluation().bCommandChanged_)
+                    {
+                        // Don't do more than one change
+                        return;
+                    }
+                }
+            }
+            case CS_Params:
+            {
+                if (CommandExecutor::getEvaluation().listOfPossibleArguments_.size() == 1)
+                {
+                    // There is exactly one possible argument
+                    CommandExecutor::getEvaluation().argument_ = (*CommandExecutor::getEvaluation().listOfPossibleArguments_.begin()).getString();
+                    CommandExecutor::getEvaluation().possibleArgument_ = (*CommandExecutor::getEvaluation().listOfPossibleArguments_.begin()).getString();
+                    CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
                     return;
                 }
+                else if (CommandExecutor::getEvaluation().listOfPossibleArguments_.size() == 0)
+                {
+                    // The user tries something new - we let him do
+                    CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
+                    CommandExecutor::getEvaluation().argument_ = CommandExecutor::getLastArgument();
+                    return;
+                }
+                else
+                {
+                    // There are several possibilities
+                    unsigned int argumentNumber = CommandExecutor::argumentsGiven();
+                    if (argumentNumber > 0)
+                        --argumentNumber;
+                    if (CommandExecutor::getEvaluation().functionclass_ && argumentNumber > 0)
+                        --argumentNumber;
+
+                    CommandExecutor::getEvaluation().argument_ = CommandExecutor::getCommonBegin(CommandExecutor::getEvaluation().listOfPossibleArguments_);
+                    CommandExecutor::getEvaluation().possibleArgument_ = CommandExecutor::getPossibleArgument(CommandExecutor::getLastArgument(), CommandExecutor::getEvaluation().function_, argumentNumber);
+                    CommandExecutor::getEvaluation().state_ = CS_ParamPreparation;
+                    return;
+                }
+            }
+            case CS_Finished:
+            {
+                // Nothing more to do
                 break;
-            case CS_FunctionClass_Or_Shortcut_Or_Keyword:
-                if (CommandExecutor::argumentsGiven() >= 1)
-                {
-                    if ((CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE) || (CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY))
-                    {
-                        // We want to set a config value
-                        CommandExecutor::getEvaluation().state_ = CS_ConfigValueClass;
-                        CommandExecutor::parse(command, false);
-                        return;
-                    }
-                    else if (CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_KEYBIND)
-                    {
-                        // We want to set a keybinding
-                        CommandExecutor::getEvaluation().state_ = CS_KeybindKey;
-                        CommandExecutor::parse(command, false);
-                        return;
-                    }
-
-                    if (!CommandExecutor::getEvaluation().functionclass_)
-                        CommandExecutor::getEvaluation().functionclass_ = CommandExecutor::getIdentifierOfPossibleFunctionClass(CommandExecutor::getToken(0));
-                    if (!CommandExecutor::getEvaluation().shortcut_)
-                        CommandExecutor::getEvaluation().shortcut_ = CommandExecutor::getExecutorOfPossibleShortcut(CommandExecutor::getToken(0));
-
-                    if ((!CommandExecutor::getEvaluation().functionclass_) && (!CommandExecutor::getEvaluation().shortcut_))
-                    {
-                        // Argument 1 seems to be wrong
-                        AddLanguageEntry("CommandExecutor::NoSuchCommandOrClassName", "No such command or classname");
-                        CommandExecutor::getEvaluation().errorMessage_ = (CommandExecutor::getToken(0) + ": " + GetLocalisation("CommandExecutor::NoSuchCommandOrClassName"));
-                        CommandExecutor::getEvaluation().state_ = CS_Error;
-                        return;
-                    }
-                    else if (CommandExecutor::getEvaluation().shortcut_)
-                    {
-                        // Argument 1 is a shortcut: Return the needed parameter types
-                        CommandExecutor::getEvaluation().state_ = CS_Shortcut_Params;
-                        CommandExecutor::parse(command, false);
-                        return;
-                    }
-                    else
-                    {
-                        // Argument 1 is a classname: Return the possible functions
-                        CommandExecutor::getEvaluation().state_ = CS_Function;
-                        CommandExecutor::parse(command, false);
-                        return;
-                    }
-                }
-                else
-                {
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
+            }
+            case CS_Error:
+            {
+                // Bad, very bad
                 break;
-            case CS_Shortcut_Params:
-                if (CommandExecutor::getEvaluation().shortcut_)
-                {
-                    // Valid command
-                    // Check if there are enough parameters
-                    if (CommandExecutor::enoughParametersGiven(1, CommandExecutor::getEvaluation().shortcut_))
-                    {
-                        CommandExecutor::getEvaluation().state_ = CS_Shortcut_Finished;
-                        return;
-                    }
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_Function:
-                if (CommandExecutor::getEvaluation().functionclass_)
-                {
-                    // We have a valid classname
-                    // Check if there is a second argument
-                    if (CommandExecutor::argumentsGiven() >= 2)
-                    {
-                        // There is a second argument: Check if it's a valid functionname
-                        CommandExecutor::getEvaluation().function_ = CommandExecutor::getExecutorOfPossibleFunction(CommandExecutor::getToken(1), CommandExecutor::getEvaluation().functionclass_);
-                        if (!CommandExecutor::getEvaluation().function_)
-                        {
-                            // Argument 2 seems to be wrong
-                            AddLanguageEntry("CommandExecutor::NoSuchFunctionnameIn", "No such functionname in");
-                            CommandExecutor::getEvaluation().errorMessage_ = (CommandExecutor::getToken(1) + ": " + GetLocalisation("CommandExecutor::NoSuchFunctionnameIn") + " " + CommandExecutor::getEvaluation().functionclass_->getName());
-                            CommandExecutor::getEvaluation().state_ = CS_Error;
-                            return;
-                        }
-                        else
-                        {
-                            // Argument 2 seems to be a valid functionname: Get the parameters
-                            CommandExecutor::getEvaluation().state_ = CS_Function_Params;
-                            CommandExecutor::parse(command, false);
-                            return;
-                        }
-                    }
-                    else
-                    {
-                        // There is no finished second argument
-                        // Check if there's already a perfect match
-                        if (CommandExecutor::getEvaluation().tokens_.size() >= 2)
-                        {
-                            CommandExecutor::getEvaluation().function_ = CommandExecutor::getExecutorOfPossibleFunction(CommandExecutor::getToken(1), CommandExecutor::getEvaluation().functionclass_);
-                            if (CommandExecutor::getEvaluation().function_)
-                            {
-                                // There is a perfect match: Add a whitespace and continue parsing
-                                CommandExecutor::getEvaluation().state_ = CS_Function_Params;
-                                CommandExecutor::parse(command + " ", false);
-                                return;
-                            }
-                        }
-
-                        // No perfect match: Create the list of all possible functions and return
-                        CommandExecutor::createListOfPossibleFunctions(CommandExecutor::getToken(1), CommandExecutor::getEvaluation().functionclass_);
-
-                        // Check if there's only one possiblility
-                        if (CommandExecutor::getEvaluation().listOfPossibleFunctions_.size() == 1)
-                        {
-                            // There's only one possible function
-                            CommandExecutor::getEvaluation().state_ = CS_Function_Params;
-                            CommandExecutor::getEvaluation().function_ = CommandExecutor::getExecutorOfPossibleFunction(*(*CommandExecutor::getEvaluation().listOfPossibleFunctions_.begin()).first, CommandExecutor::getEvaluation().functionclass_);
-                            CommandExecutor::parse(CommandExecutor::getToken(0) + " " + *(*CommandExecutor::getEvaluation().listOfPossibleFunctions_.begin()).first + " ", false);
-                            return;
-                        }
-
-                        // It's ambiguous
-                        return;
-                    }
-                }
-                else
-                {
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_Function_Params:
-                if (CommandExecutor::getEvaluation().functionclass_ && CommandExecutor::getEvaluation().function_)
-                {
-                    // Valid command
-                    // Check if there are enough parameters
-                    if (CommandExecutor::enoughParametersGiven(2, CommandExecutor::getEvaluation().function_))
-                    {
-                        CommandExecutor::getEvaluation().state_ = CS_Function_Finished;
-                        return;
-                    }
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_ConfigValueClass:
-                if (((CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE) || (CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY)))
-                {
-                    // We want to set a config value
-                    // Check if there is a second argument
-                    if (CommandExecutor::argumentsGiven() >= 2)
-                    {
-                        // There is a second argument: Check if it's a valid classname
-                        CommandExecutor::getEvaluation().configvalueclass_ = CommandExecutor::getIdentifierOfPossibleConfigValueClass(CommandExecutor::getToken(1));
-                        if (!CommandExecutor::getEvaluation().configvalueclass_)
-                        {
-                            // Argument 2 seems to be wrong
-                            AddLanguageEntry("CommandExecutor::NoSuchClassWithConfigValues", "No such class with config values");
-                            CommandExecutor::getEvaluation().errorMessage_ = (CommandExecutor::getToken(1) + ": " + GetLocalisation("CommandExecutor::NoSuchClassWithConfigValues"));
-                            CommandExecutor::getEvaluation().state_ = CS_Error;
-                            return;
-                        }
-                        else
-                        {
-                            // Argument 2 seems to be a valid classname: Search for possible config values
-                            CommandExecutor::getEvaluation().state_ = CS_ConfigValue;
-                            CommandExecutor::parse(command, false);
-                            return;
-                        }
-                    }
-                    else
-                    {
-                        // There's no finished second argument
-                        // Check if there's already a perfect match
-                        if (CommandExecutor::getEvaluation().tokens_.size() >= 2)
-                        {
-                            CommandExecutor::getEvaluation().configvalueclass_ = CommandExecutor::getIdentifierOfPossibleConfigValueClass(CommandExecutor::getToken(1));
-                            if (CommandExecutor::getEvaluation().configvalueclass_)
-                            {
-                                // There is a perfect match: Add a whitespace and continue parsing
-                                CommandExecutor::getEvaluation().state_ = CS_ConfigValue;
-                                CommandExecutor::parse(command + " ", false);
-                                return;
-                            }
-                        }
-
-                        // No perfect match: Create the list of all possible classnames and return
-                        CommandExecutor::createListOfPossibleConfigValueClasses(CommandExecutor::getToken(1));
-
-                        // Check if there's only one possiblility
-                        if (CommandExecutor::getEvaluation().listOfPossibleConfigValueClasses_.size() == 1)
-                        {
-                            // There's only one possible classname
-                            CommandExecutor::getEvaluation().state_ = CS_ConfigValue;
-                            CommandExecutor::getEvaluation().configvalueclass_ = CommandExecutor::getIdentifierOfPossibleConfigValueClass(*(*CommandExecutor::getEvaluation().listOfPossibleConfigValueClasses_.begin()).first);
-                            CommandExecutor::parse(CommandExecutor::getToken(0) + " " + *(*CommandExecutor::getEvaluation().listOfPossibleConfigValueClasses_.begin()).first + " ", false);
-                            return;
-                        }
-
-                        // It's ambiguous
-                        return;
-                    }
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_ConfigValue:
-                if (((CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE) || (CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY)) && (CommandExecutor::getEvaluation().configvalueclass_))
-                {
-                    // Check if there is a third argument
-                    if (CommandExecutor::argumentsGiven() >= 3)
-                    {
-                        // There is a third argument: Check if it's a valid config value
-                        CommandExecutor::getEvaluation().configvalue_ = CommandExecutor::getContainerOfPossibleConfigValue(CommandExecutor::getToken(2), CommandExecutor::getEvaluation().configvalueclass_);
-                        if (!CommandExecutor::getEvaluation().configvalue_)
-                        {
-                            // Argument 3 seems to be wrong
-                            AddLanguageEntry("CommandExecutor::NoSuchConfigValueIn", "No such config value in");
-                            CommandExecutor::getEvaluation().errorMessage_ = (CommandExecutor::getToken(2) + ": " + GetLocalisation("CommandExecutor::NoSuchConfigValueIn") + " " + CommandExecutor::getEvaluation().configvalueclass_->getName());
-                            CommandExecutor::getEvaluation().state_ = CS_Error;
-                            return;
-                        }
-                        else
-                        {
-                            // Argument 3 seems to be a valid config value: Get the type
-                            CommandExecutor::getEvaluation().state_ = CS_ConfigValueType;
-                            CommandExecutor::parse(command, false);
-                            return;
-                        }
-                    }
-                    else
-                    {
-                        // There is no finished third argument
-                        // Check if there's already a perfect match
-                        if (CommandExecutor::getEvaluation().tokens_.size() >= 3)
-                        {
-                            CommandExecutor::getEvaluation().configvalue_ = CommandExecutor::getContainerOfPossibleConfigValue(CommandExecutor::getToken(2), CommandExecutor::getEvaluation().configvalueclass_);
-                            if (CommandExecutor::getEvaluation().configvalue_)
-                            {
-                                // There is a perfect match: Add a whitespace and continue parsing
-                                CommandExecutor::getEvaluation().state_ = CS_ConfigValueType;
-                                CommandExecutor::parse(command + " ", false);
-                                return;
-                            }
-                        }
-
-                        // No perfect match: Create the list of all possible config values
-                        CommandExecutor::createListOfPossibleConfigValues(CommandExecutor::getToken(2), CommandExecutor::getEvaluation().configvalueclass_);
-
-                        // Check if there's only one possiblility
-                        if (CommandExecutor::getEvaluation().listOfPossibleConfigValues_.size() == 1)
-                        {
-                            // There's only one possible config value
-                            CommandExecutor::getEvaluation().state_ = CS_ConfigValueType;
-                            CommandExecutor::getEvaluation().configvalue_ = CommandExecutor::getContainerOfPossibleConfigValue(*(*CommandExecutor::getEvaluation().listOfPossibleConfigValues_.begin()).first, CommandExecutor::getEvaluation().configvalueclass_);
-                            CommandExecutor::parse(CommandExecutor::getToken(0) + " " + CommandExecutor::getToken(1) + " " + *(*CommandExecutor::getEvaluation().listOfPossibleConfigValues_.begin()).first + " ", false);
-                            return;
-                        }
-
-                        // It's ambiguous
-                        return;
-                    }
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_ConfigValueType:
-                if (((CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE) || (CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_CONFIG_VALUE_TEMPORARY)) && CommandExecutor::getEvaluation().configvalueclass_ && CommandExecutor::getEvaluation().configvalue_)
-                {
-                    // Valid command
-                    // Check if there are enough parameters
-                    if ((CommandExecutor::getEvaluation().tokens_.size() >= 4) && (CommandExecutor::getEvaluation().tokens_[3] != COMMAND_EXECUTOR_CURSOR))
-                    {
-                        CommandExecutor::getEvaluation().state_ = CS_ConfigValueFinished;
-                        return;
-                    }
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_KeybindKey:
-                if ((CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_KEYBIND))
-                {
-                    // todo
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_KeybindCommand:
-                if ((CommandExecutor::getToken(0) == COMMAND_EXECUTOR_KEYWORD_SET_KEYBIND) && (false)) // todo
-                {
-                    // Valid command
-                    // Check if there are enough parameters
-                    if (CommandExecutor::getEvaluation().tokens_.size() >= 3)
-                    {
-                        CommandExecutor::getEvaluation().state_ = CS_KeybindFinished;
-                        return;
-                    }
-
-                }
-                else
-                {
-                    // Something is wrong
-                    CommandExecutor::getEvaluation().state_ = CS_Error;
-                    return;
-                }
-                break;
-            case CS_Shortcut_Finished:
-                // Nothing to do
-                break;
-            case CS_Function_Finished:
-                // Nothing to do
-                break;
-            case CS_ConfigValueFinished:
-                // Nothing to do
-                break;
-            case CS_KeybindFinished:
-                // Nothing to do
-                break;
-            case CS_Error:
-                // This is bad
-                break;
-        }
-    }
-
-    void CommandExecutor::initialize(const std::string& command)
-    {
-        CommandExecutor::getEvaluation().processedCommand_ = command;
-        CommandExecutor::getEvaluation().additionalParameter_ = "";
-
-        CommandExecutor::getEvaluation().bEvaluatedParams_ = false;
-        CommandExecutor::getEvaluation().evaluatedExecutor_ = 0;
-
-        CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.clear();
-        CommandExecutor::getEvaluation().listOfPossibleShortcuts_.clear();
+            }
+        }
+    }
+
+    unsigned int CommandExecutor::argumentsFinished()
+    {
+        unsigned int argumentsGiven = CommandExecutor::argumentsGiven();
+        if (argumentsGiven > 0)
+            return argumentsGiven - 1;
+        else
+            return 0;
+    }
+
+    unsigned int CommandExecutor::argumentsGiven()
+    {
+        if (CommandExecutor::getEvaluation().command_.size() > 0 && CommandExecutor::getEvaluation().command_[CommandExecutor::getEvaluation().command_.size() - 1] == ' ')
+            return CommandExecutor::getEvaluation().commandTokens_.size() + 1;
+        else
+            return CommandExecutor::getEvaluation().commandTokens_.size();
+    }
+
+    bool CommandExecutor::enoughArgumentsGiven(ConsoleCommand* command)
+    {
+        if (CommandExecutor::getEvaluation().functionclass_)
+            return (CommandExecutor::argumentsGiven() > (2 + command->getParamCount()));
+        else
+            return (CommandExecutor::argumentsGiven() > (1 + command->getParamCount()));
+    }
+
+    std::string CommandExecutor::getArgument(unsigned int index)
+    {
+        if (index < (CommandExecutor::getEvaluation().commandTokens_.size()))
+            return CommandExecutor::getEvaluation().commandTokens_[index];
+        else
+            return "";
+    }
+
+    std::string CommandExecutor::getLastArgument()
+    {
+        return CommandExecutor::getArgument(CommandExecutor::argumentsGiven() - 1);
+    }
+
+    void CommandExecutor::createListOfPossibleIdentifiers(const std::string& fragment)
+    {
+        CommandExecutor::getEvaluation().listOfPossibleIdentifiers_.clear();
+        std::string lowercase = getLowercase(fragment);
+        for (std::map<std::string, Identifier*>::const_iterator it = Identifier::getLowercaseIdentifierMapBegin(); it != Identifier::getLowercaseIdentifierMapEnd(); ++it)
+            if ((*it).second->hasConsoleCommands())
+                if ((*it).first.find(lowercase) == 0 || fragment == "")
+                    CommandExecutor::getEvaluation().listOfPossibleIdentifiers_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
+    }
+
+    void CommandExecutor::createListOfPossibleFunctions(const std::string& fragment, Identifier* identifier)
+    {
         CommandExecutor::getEvaluation().listOfPossibleFunctions_.clear();
-        CommandExecutor::getEvaluation().listOfPossibleConfigValueClasses_.clear();
-        CommandExecutor::getEvaluation().listOfPossibleConfigValues_.clear();
-        CommandExecutor::getEvaluation().listOfPossibleKeys_.clear();
-
-        CommandExecutor::getEvaluation().functionclass_ = 0;
-        CommandExecutor::getEvaluation().configvalueclass_ = 0;
-        CommandExecutor::getEvaluation().shortcut_ = 0;
-        CommandExecutor::getEvaluation().function_ = 0;
-        CommandExecutor::getEvaluation().configvalue_ = 0;
-        CommandExecutor::getEvaluation().key_ = 0;
-
-        CommandExecutor::getEvaluation().errorMessage_ = "";
-        CommandExecutor::getEvaluation().state_ = CS_Empty;
-    }
-
-    bool CommandExecutor::argumentsGiven(unsigned int num)
-    {
-        // Because we added a cursor we have +1 arguments
-        // There are num arguments given if there are at least num arguments + one cursor
-        return (CommandExecutor::getEvaluation().tokens_.size() >= (num + 1));
-    }
-
-    unsigned int CommandExecutor::argumentsGiven()
-    {
-        // Because we added a cursor we have +1 arguments
-        if (CommandExecutor::getEvaluation().tokens_.size() >= 1)
-            return (CommandExecutor::getEvaluation().tokens_.size() - 1);
-        else
-            return 0;
-    }
-
-    std::string CommandExecutor::getToken(unsigned int index)
-    {
-        if ((index >= 0) && (index < (CommandExecutor::getEvaluation().tokens_.size() - 1)))
-            return CommandExecutor::getEvaluation().tokens_[index];
-        else if (index == (CommandExecutor::getEvaluation().tokens_.size() - 1))
-            return CommandExecutor::getEvaluation().tokens_[index].substr(0, CommandExecutor::getEvaluation().tokens_[index].size() - 1);
-        else
-            return "";
-    }
-
-    bool CommandExecutor::enoughParametersGiven(unsigned int head, Executor* executor)
-    {
-        unsigned int neededParams = head + executor->getParamCount();
-        /*
-        for (unsigned int i = executor->getParamCount() - 1; i >= 0; i--)
-        {
-            if (executor->defaultValueSet(i))
-                neededParams--;
+        std::string lowercase = getLowercase(fragment);
+        if (!identifier)
+        {
+            for (std::map<std::string, ConsoleCommand*>::const_iterator it = CommandExecutor::getLowercaseConsoleCommandShortcutMapBegin(); it != CommandExecutor::getLowercaseConsoleCommandShortcutMapEnd(); ++it)
+                if ((*it).first.find(lowercase) == 0 || fragment == "")
+                    CommandExecutor::getEvaluation().listOfPossibleFunctions_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
+        }
+        else
+        {
+            for (std::map<std::string, ConsoleCommand*>::const_iterator it = identifier->getLowercaseConsoleCommandMapBegin(); it != identifier->getLowercaseConsoleCommandMapEnd(); ++it)
+                if ((*it).first.find(lowercase) == 0 || fragment == "")
+                    CommandExecutor::getEvaluation().listOfPossibleFunctions_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
+        }
+    }
+
+    void CommandExecutor::createListOfPossibleArguments(const std::string& fragment, ConsoleCommand* command, unsigned int param)
+    {
+        CommandExecutor::createArgumentCompletionList(command, param);
+
+        CommandExecutor::getEvaluation().listOfPossibleArguments_.clear();
+        std::string lowercase = getLowercase(fragment);
+        for (ArgumentCompletionList::const_iterator it = command->getArgumentCompletionListBegin(); it != command->getArgumentCompletionListEnd(); ++it)
+        {
+            if ((*it).lowercaseComparison())
+            {
+                if ((*it).getComparable().find(lowercase) == 0 || fragment == "")
+                    CommandExecutor::getEvaluation().listOfPossibleArguments_.push_back(*it);
+            }
             else
-                break;
-        }
-        */
-        return ((CommandExecutor::getEvaluation().tokens_.size() >= neededParams) && (CommandExecutor::getEvaluation().tokens_[neededParams - 1] != COMMAND_EXECUTOR_CURSOR));
-    }
-
-    void CommandExecutor::createListOfPossibleFunctionClasses(const std::string& fragment)
-    {
-        for (std::map<std::string, Identifier*>::const_iterator it = Identifier::getLowercaseIdentifierMapBegin(); it != Identifier::getLowercaseIdentifierMapEnd(); ++it)
-        {
-            if ((*it).second->hasConsoleCommands())
-            {
-                if ((*it).first.find(getLowercase(fragment)) == 0 || fragment == "")
-                {
-                    CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
-                }
-            }
-        }
-
-        CommandExecutor::getEvaluation().listOfPossibleFunctionClasses_.sort(CommandExecutor::compareStringsInList);
-    }
-
-    void CommandExecutor::createListOfPossibleShortcuts(const std::string& fragment)
-    {
-        for (std::map<std::string, ExecutorStatic*>::const_iterator it = CommandExecutor::getLowercaseConsoleCommandShortcutMapBegin(); it != CommandExecutor::getLowercaseConsoleCommandShortcutMapEnd(); ++it)
-        {
-            if ((*it).first.find(getLowercase(fragment)) == 0 || fragment == "")
-            {
-                CommandExecutor::getEvaluation().listOfPossibleShortcuts_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
-            }
-        }
-
-        CommandExecutor::getEvaluation().listOfPossibleShortcuts_.sort(CommandExecutor::compareStringsInList);
-    }
-
-    void CommandExecutor::createListOfPossibleFunctions(const std::string& fragment, Identifier* identifier)
-    {
-        for (std::map<std::string, ExecutorStatic*>::const_iterator it = identifier->getLowercaseConsoleCommandMapBegin(); it != identifier->getLowercaseConsoleCommandMapEnd(); ++it)
-        {
-            if ((*it).first.find(getLowercase(fragment)) == 0 || fragment == "")
-            {
-                CommandExecutor::getEvaluation().listOfPossibleFunctions_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
-            }
-        }
-
-        CommandExecutor::getEvaluation().listOfPossibleFunctions_.sort(CommandExecutor::compareStringsInList);
-    }
-
-    void CommandExecutor::createListOfPossibleConfigValueClasses(const std::string& fragment)
-    {
-        for (std::map<std::string, Identifier*>::const_iterator it = Identifier::getLowercaseIdentifierMapBegin(); it != Identifier::getLowercaseIdentifierMapEnd(); ++it)
-        {
-            if ((*it).second->hasConfigValues())
-            {
-                if ((*it).first.find(getLowercase(fragment)) == 0 || fragment == "")
-                {
-                    CommandExecutor::getEvaluation().listOfPossibleConfigValueClasses_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
-                }
-            }
-        }
-
-        CommandExecutor::getEvaluation().listOfPossibleConfigValueClasses_.sort(CommandExecutor::compareStringsInList);
-    }
-
-    void CommandExecutor::createListOfPossibleConfigValues(const std::string& fragment, Identifier* identifier)
-    {
-        for (std::map<std::string, ConfigValueContainer*>::const_iterator it = identifier->getLowercaseConfigValueMapBegin(); it != identifier->getLowercaseConfigValueMapEnd(); ++it)
-        {
-            if ((*it).first.find(getLowercase(fragment)) == 0 || fragment == "")
-            {
-                CommandExecutor::getEvaluation().listOfPossibleConfigValues_.push_back(std::pair<const std::string*, const std::string*>(&(*it).first, &(*it).second->getName()));
-            }
-        }
-
-        CommandExecutor::getEvaluation().listOfPossibleConfigValues_.sort(CommandExecutor::compareStringsInList);
-    }
-
-    void CommandExecutor::createListOfPossibleKeys(const std::string& fragment)
-    {
-        // todo
-
-        CommandExecutor::getEvaluation().listOfPossibleKeys_.sort(CommandExecutor::compareStringsInList);
-    }
-
-    bool CommandExecutor::compareStringsInList(const std::pair<const std::string*, const std::string*>& first, const std::pair<const std::string*, const std::string*>& second)
-    {
-        return ((*first.first) < (*second.first));
-    }
-
-    Identifier* CommandExecutor::getIdentifierOfPossibleFunctionClass(const std::string& name)
-    {
-        std::map<std::string, Identifier*>::const_iterator it = Identifier::getLowercaseIdentifierMap().find(getLowercase(name));
+            {
+                if ((*it).getComparable().find(fragment) == 0 || fragment == "")
+                    CommandExecutor::getEvaluation().listOfPossibleArguments_.push_back(*it);
+            }
+        }
+    }
+
+    Identifier* CommandExecutor::getPossibleIdentifier(const std::string& name)
+    {
+        std::string lowercase = getLowercase(name);
+        std::map<std::string, Identifier*>::const_iterator it = Identifier::getLowercaseIdentifierMap().find(lowercase);
         if ((it != Identifier::getLowercaseIdentifierMapEnd()) && (*it).second->hasConsoleCommands())
             return (*it).second;
